// sa crveno-crnim stablima i brisanjem za 75 minuta ovo ne moze.

#include <stdio.h>

struct cvor
{
    char ime[ 50 ];
    int uzrast, broj_igracaka, balans;

    struct cvor *l, *d;
};

int max( int x, int y )
{
    if ( x > y ) return x;

    return y;
}

int dubina( struct cvor *koren )
{
    if ( koren ) return 1 + max( dubina( koren -> l ), dubina( koren -> d ) );

    return 0;
}

void lrotacija( struct cvor **koren )
{
    struct cvor *pl = *koren;
    struct cvor *pd = pl -> d;

    pl -> d = pd -> l;
    pd -> l = pl;

    *koren = pd;

    pl -> balans = dubina( pl -> d ) - dubina( pl -> l );
    pd -> balans = dubina( pd -> d ) - dubina( pd -> l );
}

int vece_jednako( struct cvor *x, struct cvor *y )
{
    if ( x -> uzrast > y -> uzrast ) return 1;

    if ( x -> uzrast == y -> uzrast && strcmp( x -> ime, y -> ime ) >= 0 ) return 1;

    return 0;
}

void drotacija( struct cvor **koren )
{
    struct cvor *pd = *koren;
    struct cvor *pl = pd -> l;

    pd -> l = pl -> d;
    pl -> d = pd;

    *koren = pl;

    pl -> balans = dubina( pl -> d ) - dubina( pl -> l );
    pd -> balans = dubina( pd -> d ) - dubina( pd -> l );
}

int dodaj( struct cvor **koren, struct cvor novi )
{
    int inkrement, rezultat = 0;

    struct cvor *t = *koren;

    if ( !t )
    {
        t = ( struct cvor * ) malloc( sizeof( struct cvor ) );

        *t = novi;
        t -> l = t -> d = NULL;
        t -> balans = 0;

        *koren = t;
        return 1;
    }

    if ( vece_jednako( &novi, t ) ) inkrement = dodaj( &( t -> d ), novi );
    else inkrement = - dodaj( &( t -> l ), novi );

    t -> balans += inkrement;

    if ( inkrement && t -> balans )

        if ( t -> balans < -1 )
            if ( t -> l -> balans < 0 ) drotacija( &t );
            else { lrotacija( &( t -> l ) ); drotacija( &t ); }

        else if ( t -> balans > 1 )
            if ( t -> d -> balans > 0 ) lrotacija( &t );
            else { drotacija( &( t -> d ) ); lrotacija( &t ); }

        else rezultat = 1;

    *koren = t;

    return rezultat;
}

void ispis_od_najstarijeg( struct cvor *koren )
{
    if ( koren )
    {
        ispis_od_najstarijeg( koren -> d );
        printf("%s %d %d\n", koren -> ime, koren -> uzrast, koren -> broj_igracaka );
        ispis_od_najstarijeg( koren -> l );
    }
}

void napravi_novo( struct cvor **novo, struct cvor *staro, int x )
{
    if ( staro )
    {
        if ( staro -> uzrast / 12 < x ) dodaj( novo, *staro );
        napravi_novo( novo, staro -> l, x );
        napravi_novo( novo, staro -> d, x );
    }
}

void stampaj_k_m( struct cvor *koren, int k, int m, int nivo )
{
    if ( !koren ) return;

    if ( nivo == k )
    {
        if ( koren -> broj_igracaka == m ) printf("%s %d %d\n", koren -> ime, koren -> uzrast, koren -> broj_igracaka );

        return;
    }

    stampaj_k_m( koren -> l, k, m, nivo + 1 );
    stampaj_k_m( koren -> d, k, m, nivo + 1 );
}

int main()
{
    struct cvor *koren = NULL;

    int n;
    scanf("%d", &n ); getchar();

    while( n -- )
    {
        struct cvor novi;

        scanf("%s", novi. ime );
        scanf("%d", &novi. uzrast );getchar();
        scanf("%d", &novi. broj_igracaka );getchar();

        dodaj( &koren, novi );
    }

    ispis_od_najstarijeg( koren );

    struct cvor *novo_stablo = NULL;

    int x;
    scanf("%d", &x );

    napravi_novo( &novo_stablo, koren, x );

    ispis_od_najstarijeg( novo_stablo );

    int m, k, nivo = 1;
    scanf("%d%d", &k, &m );

    stampaj_k_m( novo_stablo, k, m, nivo );

    return 0;
}
