#include <stdio.h>
#include <stdlib.h>
#include <string.h>

struct dete
{
	char ime[10];
	int uzrast; //u mesecima
	int brojIgr;
	int balans;
	struct dete *levi,*desni;	
};

#define novi(x) x=(struct dete *)malloc(sizeof(struct dete))

int dubina(struct dete *p)
{
	if(p)
	{
		int dd=0,dl=0;
		
		if(p->levi) dl=dubina(p->levi);
		if(p->desni) dd=dubina(p->desni);
		
		if(dl > dd) return ++dl;
		else return ++dd;		
	}
	else return 0;
}

void lrotacija(struct dete **t)
{
	struct dete *poml,*pomd;
	
	poml=*t;
	pomd=poml->desni;
	
	poml->desni=pomd->levi;
	pomd->levi=poml;
	
	*t=pomd;
	
	poml->balans=dubina(poml->desni) - dubina(poml->levi);
	pomd->balans=dubina(pomd->desni) - dubina(pomd->levi);	
}

void drotacija(struct dete **t)
{
	struct dete *poml,*pomd;
	
	pomd=*t;
	poml=pomd->levi;
	
	pomd->levi=poml->desni;
	poml->desni=pomd;
	
	*t=poml;
	
	poml->balans=dubina(poml->desni) - dubina(poml->levi);
	pomd->balans=dubina(pomd->desni) - dubina(pomd->levi);	
}

int dodaj(struct dete **p, char *ime, int uzrast, int brojIgr)
{
	struct dete *t=NULL;
	int rezultat=0, inkrement;
	
	t=*p;
	if(!t)
	{
		novi(t);
		if(!t)
		{
			printf("Greška pri alokaciji memorije\n");
			exit(69);
		}
		else
		{
			t->balans=0;
			t->uzrast=uzrast;
			t->brojIgr=brojIgr;
			t->levi=NULL;
			t->desni=NULL;
			strcpy(t->ime,ime);
			rezultat=1;			 
		}
	}
	else
	{
		if(uzrast > t->uzrast) inkrement=dodaj(&(t->desni),ime,uzrast,brojIgr);
		else if(uzrast < t->uzrast) inkrement=-dodaj(&(t->levi),ime,uzrast,brojIgr);
		else
		{
			if(strcmp(t->ime,ime) > 0) inkrement=-dodaj(p,ime,uzrast,brojIgr);
			else inkrement=dodaj(p,ime,uzrast,brojIgr);
		}
		
		t->balans+=inkrement;
		
		if(inkrement!=0 && t->balans!=0)
		{
			if(t->balans < -1)
			{
				if(t->balans < 0) drotacija(&t);
				else
				{
					lrotacija(&(t->levi));
					drotacija(&t);
				}
			}
			else if(t->balans > 1)
			{
				if(t->balans > 0) lrotacija(&t);
				else
				{
					drotacija(&(t->desni));
					lrotacija(&t);
				}
			}
			else rezultat=1;
		}
	}
	*p=t;
	return rezultat;
}

struct dete *form()
{
	struct dete *p=NULL;
	int i,n,brojIgr,uzrast;
	char ime[10];
	
	printf("Unesi broj dece: ");
	scanf("%d",&n);
	
	for(i=0; i<n; i++)
	{
		printf("Uneti ime deteta: ");
		scanf("%s",ime);
		
		printf("Uneti uzrast deteta: ");
		scanf("%d",&uzrast);
		
		printf("Uneti broj igracaka: ");
		scanf("%d",&brojIgr);
		
		dodaj(&p,ime,uzrast,brojIgr);
		
	}
	return p;
}

void ispis(struct dete *p)
{
	if(p)
	{
		if(p->desni) ispis(p->desni);
		printf("\n%s ima %d meseci i želi %d poklona",p->ime,p->uzrast,p->brojIgr);
		if(p->levi) ispis(p->levi);
	}
	else printf("\nNema više dece\n");
}

void obrisi(struct dete **q, struct dete *p, int x)
{
	if(p)
	{
		if(p->levi) obrisi(q,p->levi,x);
		if(p->desni) obrisi(q,p->desni,x);
		
		if(p->uzrast <= x) dodaj(q,p->ime,p->uzrast,p->brojIgr);
	}
}

void nivo(int d, struct dete *p, int k, int m)
{
	if(p)
	{
		if(p->desni) nivo(d,p->desni,k,m);
		if((d-dubina(p))==k && p->brojIgr==m) printf("%s je na %d nivou i želi %d poklona\n",p->ime,k,m);
		if(p->levi) nivo(d,p->levi,k,m);		
	}
	else printf("Nema više dece\n");
}

int main()
{
	struct dete *p=NULL,*q=NULL;
	
	p=form();
	ispis(p);

	
	int x;
	printf("\n\nSa koliko godina deca prestaju da dobijaju pokone?\n");
	scanf("%d",&x);
	x*=12;
	
	obrisi(&q,p,x);
	ispis(q);
	
	int k,m;
	printf("\n\nUneti nivo k: ");
	scanf("%d",&k);
	
	printf("Uneti broj poklona m: ");
	scanf("%d",&m);
	
	
	int d;
	d=dubina(q);
	
//	printf("root je %d",d);
	
	printf("\n\n");
	nivo(d,q,k,m);
	
	
	
	return 42;
}
