/*Za svako dete se unosi IME (jedna reč), UZRAST u mesecima (ceo broj), BROJ_IGRACAKA (ceo broj). Deca treba da
budu uređena prvo po uzrastu, a zatim po imenu. Dete koje je ima isto ime i isto meseci se inicijalno stavlja u
desno podstablo u odnosu na posmatrani čvor. Na ulazu se najpre zadaje nenegativan ceo broj N koji predstavlja
broj dece koja dobijaju poklone, a zatim se za svako dete unose ime, uzrast i broj igračaka */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

typedef struct st
{
	char *ime;
	int uzrast;
	int broj;
	int balans;
	struct st *levi;
	struct st *desni;
}stablo;

#define novi(x) x = (stablo*)malloc(sizeof(stablo))
#define novic(x, s) x = (char*)malloc(strlen(s)+1)

void Ispis (stablo *p)
{
	if (p)
	{
		Ispis(p->desni);
		printf("%s   %d   %d\n", p->ime, p->uzrast, p->broj);
		Ispis(p->levi);
	}
}

int Dubina (stablo *p)
{
	int dd = 0, dl = 0;
	
	if (p)
	{
		if (p->levi) Dubina(p->levi);
		if (p->desni) Dubina(p->desni);
		if (dd > dl) return ++dd;
		else return ++dl;
	}
	else return 0;
}

void leva_rotacija (stablo **p)
{
	stablo *poml, *pomd;
	
	poml = *p;
	pomd = (*p)->desni;
	poml->desni = pomd->levi;
	pomd->levi = poml;
	*p = pomd;
	
	poml->balans = Dubina(poml->desni) - Dubina(poml->levi);
	pomd->balans = Dubina(pomd->desni) - Dubina(pomd->levi);
}

void desna_rotacija (stablo **p)
{
	stablo *poml, *pomd;
	
	pomd = *p;
	poml = (*p)->levi;
	pomd->levi = poml->desni;
	poml->desni = pomd;
	*p = poml;
	
	poml->balans = Dubina(poml->desni) - Dubina(poml->levi);
	pomd->balans = Dubina(pomd->desni) - Dubina(pomd->levi);
}
	
int Dodaj (stablo **t, char *ime, int uzrast, int broj)
{
	stablo *p = *t;
	int rezultat = 0, inkrement = 0;
	
	if (p == NULL)
	{
		novi(p);
		novic(p->ime, ime);
		strcpy(p->ime, ime);
		p->uzrast = uzrast;
		p->broj = broj;
		p->balans = 0;
		p->levi = p->desni = 0;
		rezultat = 1;
	}
	else
	{
		
		if (uzrast > p->uzrast) inkrement = Dodaj(&(p->desni), ime, uzrast, broj);
		else if (uzrast == p->uzrast)
		{
			if (strcmp(ime, p->ime) >= 0)  inkrement = Dodaj(&(p->desni), ime, uzrast, broj);
			else inkrement = -Dodaj(&(p->levi), ime, uzrast, broj);
		
		}
		else inkrement = -Dodaj(&(p->levi), ime, uzrast, broj);
	
		p->balans += inkrement;
		
		if (p->balans != 0 && inkrement != 0)
		{
			if (p->balans < -1)
			{
				if (p->levi->balans < 0) desna_rotacija(&p);
				else
				{
					leva_rotacija(&(p->levi));
					desna_rotacija(&p);
				}
			}
			if (p->balans > 1)
			{
				if (p->balans > 0) leva_rotacija(&p);
				else
				{
					desna_rotacija(&(p->desni));
					leva_rotacija(&p);
				}
			}
			else rezultat = 1;
		}
	}
	
	*t = p;
	return rezultat;
}		

stablo* Formiraj (stablo *p, FILE *f)
{
	int i, n, u, b;
	char ime[50];
	
	fscanf(f, "%d", &n);
	
	for (i = 0; i < n; i++)
	{
		fscanf(f, "%s", ime);
		fscanf(f, "%d", &u);
		fscanf(f, "%d", &b);
	//	printf("%s %d %d\n", ime, u, b);
		Dodaj(&p, ime, u, b);
	}
	fclose(f);
	return p;
}



void Novo_Stablo (stablo *p, stablo **q, int x)
{
	if (p)
	{
		if ((p->uzrast/12)+1 < x) 
		{
			printf("%d \n",  (p->uzrast/12)+1);
			Dodaj(q, p->ime, p->uzrast, p->broj);
		}
		Novo_Stablo(p->levi, q, x);
		Novo_Stablo(p->desni, q, x);		
	}
}

void Nivo (stablo *p, stablo *q, int *n)
{
	/*if (p && q)
	{
		if (p == q) return;
		else
		{
			if (p->levi) 
			{
				(*n)++;
				Nivo(p->levi,q, n);
			}
			if (p->desni) 
			{
				(*n)++;
				Nivo(p->desni,q, n);
			}
		}
	}
		*/
}

void Nadji_Decu (stablo *p, stablo *q, int k, int m)
{
	int n = 0;
	Nivo(p, q, &n);
	if ( n == k && q->broj == m) Ispis(q);
	Nadji_Decu(p, p->levi, k, m);
	Nadji_Decu(p, p->desni, k, m);
}

int main (int argc, char *argv[])
{
	FILE *f = fopen(argv[1], "r");
	stablo *p = NULL, *q = NULL;
	int x, k, m;
	p = Formiraj(p, f);
	if (p)
	{
		Ispis(p);
		printf("Unesi X\n");
		scanf("%d", &x);
		Novo_Stablo (p, &q, x);
		printf("Novi raspored dece\n");
		Ispis(q);
		printf("Unesi k\n");
		scanf("%d", &k);
		printf("Unesi m\n");
		scanf("%d", &m);
		Nadji_Decu(q, q, k, m);
	}
	else printf ("Stablo je prazno\n");
	return 0;
}
