#include <stdio.h>
#include <stdlib.h>
#include <string.h>

enum {RED,BLACK};

typedef struct aa
{
	char ime[50];
	int uzrast;
	int broj;
	int boja;
	struct aa *levi,*desni,*roditelj;	
}drvo;


#define novi(x) x=(drvo*)malloc(sizeof(drvo));

void stampajdrvo(drvo *p,int i)
{
	if(p)
	{
		stampajdrvo(p->desni,i+1);
		printf("Ime: %s Uzrast: %d Broj: %d Boja: %d Nivo: %d\n",p->ime,p->uzrast,p->broj,p->boja,i);
		stampajdrvo(p->levi,i+1);
		
	}
	
}


void lrotacija(drvo **p)
{
	drvo *poml,*pomd;
	
	poml=*p;
	pomd=poml->desni;
	
	poml->desni=pomd->levi;
	
	if(pomd->levi) pomd->levi->roditelj=poml;
	
	pomd->roditelj=poml->roditelj;
	
	if(poml->roditelj)
	{
		if(poml->roditelj->levi==poml) poml->roditelj->levi=pomd;
		else poml->roditelj->desni=pomd;
	}
	
	pomd->levi	= poml;
	poml->roditelj=pomd;
	(*p)=pomd;
	
}

void drotacija(drvo **p)
{
	drvo *poml,*pomd;
	
	pomd=*p;
	poml=pomd->levi;
	
	pomd->levi=poml->desni;
	
	if(pomd->levi) pomd->levi->roditelj=pomd;
	
	poml->roditelj=pomd->roditelj;
	
	if(poml->roditelj)
	{
		if(pomd->roditelj->levi==pomd) pomd->roditelj->levi=poml;
		else pomd->roditelj->desni=poml;
	}
	
	poml->desni	= pomd;
	pomd->roditelj=poml;
	(*p)=poml;
	
}





void fixcolor(drvo **p,drvo *temp)
{
	drvo *deda,*ujak;
	
	while(temp->roditelj && temp->roditelj->boja==RED)
	{
		if(temp->roditelj == temp->roditelj->roditelj->levi)
		{
			ujak=temp->roditelj->roditelj->desni;
			deda=temp->roditelj->roditelj;
			
			if(ujak && ujak->boja==RED)
			{
				ujak->boja=BLACK;
				temp->roditelj->boja=BLACK;
				deda->boja=RED;
				temp=deda;				
			}
			else
			{
				if(temp == temp->roditelj->desni)
				{
					temp=temp->roditelj;
					lrotacija(&temp);
					if(!temp->roditelj) *p=temp;
					temp=temp->levi;							
				}
				
				deda->boja=RED;
				temp->roditelj->boja=BLACK;
				drotacija(&deda);
				if(!deda->roditelj) *p=deda;				
			}
			
			
			
			
			
			
			
		}
		else
		{
			
			ujak=temp->roditelj->roditelj->levi;
			deda=temp->roditelj->roditelj;
			
			if(ujak && ujak->boja==RED)
			{
				ujak->boja=BLACK;
				temp->roditelj->boja=BLACK;
				deda->boja=RED;
				temp=deda;				
			}
			else
			{
				if(temp == temp->roditelj->levi)
				{
					temp=temp->roditelj;
					drotacija(&temp);
					if(!temp->roditelj) *p=temp;
					temp=temp->desni;							
				}
				
				deda->boja=RED;
				temp->roditelj->boja=BLACK;
				lrotacija(&deda);
				if(!deda->roditelj) *p=deda;				
			}
							
		}
				
	}
	
	(*p)->boja=BLACK;
	
	
}





void dodaj(drvo **p,char ime[],int uzrast,int broj)
{
	drvo *temp;
	novi(temp);
	
	strcpy(temp->ime,ime);
	temp->broj=broj;
	temp->uzrast=uzrast;
	temp->levi=temp->desni=temp->roditelj=NULL;
	
	temp->boja=RED;
	
	drvo *x,*y;
	x=*p;
	y=NULL;
	while(x)
	{
		y=x;
		
		if(x->uzrast>uzrast) x=x->levi;
		else if(x->uzrast == uzrast)
		{
			if(strcmp(x->ime,ime)<0) x=x->levi;
			else x=x->desni;
		}
		else x=x->desni;	
	}
	
	temp->roditelj=y;
	if(y==NULL) *p=temp;
	else
	{
		if(y->uzrast>uzrast) y->levi=temp;
		else if(y->uzrast == uzrast)
		{
			if(strcmp(y->ime,ime)<0) y->levi=temp;
			else y->desni=temp;
		}
		else y->desni=temp;	
		
		
	}
	fixcolor(p,temp);
	
	
}


drvo *ucitajdrvo(FILE *f)
{
	int n;
	int broj,uzrast;
	char ime[50];
	drvo *p=NULL;
	
	fscanf(f,"%d",&n);
	fgetc(f);
	while(n--)
	{
		fscanf(f,"%s%d%d",ime,&uzrast,&broj);
		dodaj(&p,ime,uzrast,broj);		
	}	
	
	return p;
}

void brisi(drvo **p,drvo *q,int x)
{
	int broj;
	
	if(q!=NULL)
	{
		broj=q->uzrast + 12;
		broj=broj / 12 ;
		
		if(broj<x)
		{
			dodaj(p,q->ime,q->uzrast,q->broj);
			brisi(p,q->levi,x);
			brisi(p,q->desni,x);		
			
		}
		else
		{
			brisi(p,q->levi,x);
			brisi(p,q->desni,x);
			
		}
				
	}
	
	
}


void stampajkm(drvo *p,int k,int m,int i)
{
	if(p)
	{
			if(k==i)
			{
				if(m==p->broj)
				{
						
					printf("Ime: %s Uzrast: %d Broj: %d Boja: %d Nivo: %d\n",p->ime,p->uzrast,p->broj,p->boja,i);
				}
				stampajkm(p->levi,k,m,i+1);
				stampajkm(p->desni,k,m,i+1);
				
			}
			else
			{
				stampajkm(p->levi,k,m,i+1);
				stampajkm(p->desni,k,m,i+1);
				
			}	
		
	}	
}


void main(int argc,char *argv[])
{
	FILE *f=fopen(argv[1],"r");
	drvo *p,*q=NULL;
	
	p=ucitajdrvo(f);
	stampajdrvo(p,1);
	printf("Unesi broj godina !\n");
	int x;
	scanf("%d",&x);
	
	brisi(&q,p,x);
	stampajdrvo(q,1);
	printf("Unesi nivo i unesi broj poklona! \n");
	int k,m;
	scanf("%d%d",&k,&m);
	
	stampajkm(q,k,m,1);
	
	
	
	
	
	
}
