#include <stdio.h>
#include <stdlib.h>
#include <string.h>

enum {crvena,crna};

typedef struct podaci
{
	char ime[20];
	int uzrast;
	int broj;
} podaci;

typedef struct stablo
{
	podaci podatak;
	int boja;
	struct stablo *levi,*desni,*roditelj;
} stablo;

#define aloc(x) x=(stablo*)malloc(sizeof(stablo))

void bojedelfix(stablo **p,stablo *x);
void ispis2(stablo *p,int i,int k,int m);
stablo *naslednik(stablo *p);
stablo *nadji(stablo *p,int n);
void brisi_cvor(stablo **p,stablo *x);
void obrisi(stablo **p,int n);
void lrotacija(stablo **p);
void drotacija(stablo **p);
void bojefix(stablo **p,stablo *x);
void ispis(stablo *p,int i);
void dodaj(stablo **p,stablo *x);
void formiraj(stablo **p,char dat[]);

int main(int argc,char *argv[])
{
	if(argc!=2)
	{
		printf("Greska! Upotreba: %s ime_datoteke\n",argv[0]);
		exit(1);
	}
	stablo *p=NULL;
	
	formiraj(&p,argv[1]);
	printf("Stablo:\n");
	ispis(p,1);
	
	printf("\n\nUnesite x:");
	int x;
	scanf("%d",&x);
	obrisi(&p,x);
	printf("\n\nStablo posle brisanja:\n");
	ispis(p,1);
	printf("\nUnesite nivo i broj poklona: ");
	int k,m;
	scanf("%d%d",&k,&m);
	ispis2(p,1,k,m);
}
	
void ispis2(stablo *p,int i,int k,int m)
{
	if(p)
	{
		if((i==k)&&(p->podatak.broj==m))
		{
			if(p->boja==crvena)
			printf("(crvena,nivo=%d) %s %d %d\n",i,p->podatak.ime,p->podatak.uzrast,p->podatak.broj);
			else
			printf("(crna,nivo=%d) %s %d %d\n",i,p->podatak.ime,p->podatak.uzrast,p->podatak.broj);
		}
		ispis2(p->desni,i+1,k,m);
		ispis2(p->levi,i+1,k,m);
	}	
}

void bojedelfix(stablo **p,stablo *x)
{
	stablo *brat,*otac;
	while((x!=(*p))&&(x->boja==crna))
	{
		if(x==x->roditelj->levi)
		{
			brat=x->roditelj->desni;
			if(brat->boja==crvena)
			{
				brat->boja=crna;
				otac=x->roditelj;
				otac->boja=crvena;
				lrotacija(&otac);
				if(!otac->roditelj) *p=otac;
				brat=x->roditelj->desni;
			}
			if(brat->levi&&brat->desni)
			{
				if((brat->levi->boja==crna)&&(brat->desni->boja==crna))
				{
					brat->boja=crvena;
					x=x->roditelj;
				}
				else
				{
					if(brat->desni->boja==crna)
					{
						brat->boja=crvena;
						brat->levi->boja=crna;
						drotacija(&brat);
						if(brat->roditelj==NULL) *p=brat;
					}
					brat=x->roditelj->desni;
					otac=x->roditelj;
					brat->boja=otac->boja;
					otac->boja=crna;
					lrotacija(&otac);
					if(!otac->roditelj) *p=otac;
					x=*p;
				}
			}
		}
		else
		{
			brat=x->roditelj->levi;
			if(brat->boja==crvena)
			{
				brat->boja=crna;
				otac=x->roditelj;
				otac->boja=crvena;
				drotacija(&otac);
				if(!otac->roditelj) *p=otac;
				brat=x->roditelj->levi;
			}
			if(brat->levi&&brat->desni)
			{
				if((brat->levi->boja==crna)&&(brat->desni->boja==crna))
				{
					brat->boja=crvena;
					x=x->roditelj;
				}
				else
				{
					if(brat->levi->boja==crna)
					{
						brat->boja=crvena;
						brat->desni->boja=crna;
						lrotacija(&brat);
						if(brat->roditelj==NULL) *p=brat;
					}
					brat=x->roditelj->levi;
					otac=x->roditelj;
					brat->boja=otac->boja;
					otac->boja=crna;
					drotacija(&otac);
					if(!otac->roditelj) *p=otac;
					x=*p;
				}
			}
		}
	}
	x->boja=crna;
}
	
stablo *naslednik(stablo *p)
{
		p=p->desni;
		while(p->levi) p=p->levi;
		return p;
}

stablo *nadji(stablo *p,int n)
{
	if(p)
	{
		if(((p->podatak.uzrast+12)/12)>=n) return p;
		else return(nadji(p->desni,n));
	}
	return (NULL);
}

void brisi_cvor(stablo **p,stablo *x)
{
	stablo *tren,*sled;
	
	if((x->levi==NULL)||(x->desni==NULL))
	tren=x;
	else tren=naslednik(x);
	
	if(tren->levi) sled=tren->levi;
	else sled=tren->desni;
	
	if(sled) sled->roditelj=tren->roditelj;
	if(tren->roditelj==NULL) *p=sled;
	else
	{
		if(tren==tren->roditelj->desni) tren->roditelj->desni=sled;
		else tren->roditelj->levi=sled;
	}
	
	if(x!=tren) x->podatak=tren->podatak;
	
	if(sled&&(tren->boja==crna)) bojedelfix(p,sled);
	
	free(tren);
}


void obrisi(stablo **p,int n)
{
	stablo *x;
	x=nadji(*p,n);
	while(x)
	{
		brisi_cvor(p,x);
		x=nadji(*p,n);
	}
}

void lrotacija(stablo **p)
{
	stablo *d,*l;
	l=*p;
	d=l->desni;
	
	l->desni=d->levi;
	if(l->desni) l->desni->roditelj=l;
	
	d->roditelj=l->roditelj;
	if(l->roditelj)
	{
		if(l==l->roditelj->levi) l->roditelj->levi=d;
		else l->roditelj->desni=d;
	}
	
	d->levi=l;
	l->roditelj=d;
	
	*p=d;
}

void drotacija(stablo **p)
{
	stablo *d,*l;
	d=*p;
	l=d->levi;
	
	d->levi=l->desni;
	if(d->levi) d->levi->roditelj=d;
	
	l->roditelj=d->roditelj;
	if(d->roditelj)
	{
		if(d==d->roditelj->levi) d->roditelj->levi=l;
		else d->roditelj->desni=l;
	}
	
	l->desni=d;
	d->roditelj=l;
	
	*p=l;
}

void bojefix(stablo **p,stablo *x)
{
		stablo *ujak,*deda,*otac;
		
		while(x->roditelj&&(x->roditelj->boja==crvena))
		{
			deda=x->roditelj->roditelj;
			
			if(x->roditelj==deda->levi)
			{
				ujak=deda->desni;
				if(ujak&&(ujak->boja==crvena))
				{
					ujak->boja=crna;
					x->roditelj->boja=crna;
					deda->boja=crvena;
					x=deda;
				}
				else
				{
					if(x==x->roditelj->desni)
					{
						otac=x->roditelj;
						lrotacija(&otac);
						if(!otac->roditelj) *p=otac;
						x=otac->levi;
					}
					otac=x->roditelj;
					deda=otac->roditelj;
					otac->boja=crna;
					deda->boja=crvena;
					drotacija(&deda);
					if(!deda->roditelj) *p=deda;
					x=*p;
				}
			}
			else
			{
				ujak=deda->levi;
				if(ujak&&(ujak->boja==crvena))
				{
					ujak->boja=crna;
					x->roditelj->boja=crna;
					deda->boja=crvena;
					x=deda;
				}
				else
				{
					if(x==x->roditelj->levi)
					{
						otac=x->roditelj;
						drotacija(&otac);
						if(!otac->roditelj) *p=otac;
						x=otac->desni;
					}
					otac=x->roditelj;
					deda=otac->roditelj;
					otac->boja=crna;
					deda->boja=crvena;
					lrotacija(&deda);
					if(!deda->roditelj) *p=deda;
					x=*p;
				}
			}
		}
	(*p)->boja=crna;
}
	
void ispis(stablo *p,int i)
{
	if(p)
	{
		ispis(p->desni,i+1);
		if(p->boja==crvena)
			printf("(crvena,nivo=%d) %s %d %d\n",i,p->podatak.ime,p->podatak.uzrast,p->podatak.broj);
		else
			printf("(crna,nivo=%d) %s %d %d\n",i,p->podatak.ime,p->podatak.uzrast,p->podatak.broj);
		ispis(p->levi,i+1);
	}
}

void dodaj(stablo **p,stablo *x)
{
	stablo *pom1,*pom2;
	pom1=*p;
	pom2=NULL;
	
	while(pom1)
	{
		pom2=pom1;
		if(x->podatak.uzrast<pom1->podatak.uzrast) pom1=pom1->levi;
		else if(x->podatak.uzrast>pom1->podatak.uzrast) pom1=pom1->desni;
		else
		{
			if(strcmp(x->podatak.ime,pom1->podatak.ime)<=-1) pom1=pom1->levi;
			else pom1=pom1->desni;
		}
	}

	x->roditelj=pom2;
	if(pom2==NULL) *p=x;
	else
	{
		if(x->podatak.uzrast<pom2->podatak.uzrast) pom2->levi=x;
		else if(x->podatak.uzrast>pom2->podatak.uzrast) pom2->desni=x;
		else
		{
			if(strcmp(x->podatak.ime,pom2->podatak.ime)<=-1) pom2->levi=x;
			else pom2->desni=x;
		}
	}
	bojefix(p,x);
}

void formiraj(stablo **p,char dat[])
{
	FILE *f=fopen(dat,"r");
	if(!f)
	{
		printf("Greska prilikom otvaranja datoteke!\n");
		exit(1);
	}
	int n,i;
	stablo *x;
	fscanf(f,"%d",&n);
	
	for(i=0;i<n;i++)
	{
		aloc(x);
		fscanf(f,"%s%d%d",x->podatak.ime,&x->podatak.uzrast,&x->podatak.broj);
		x->boja=crvena;
		x->levi=x->desni=NULL;
		dodaj(p,x);
	}
	
	fclose(f);
}
