#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/*
Za svako dete se unosi IME (jedna reč), UZRAST u mesecima (ceo broj), BROJ_IGRACAKA (ceo broj). Deca treba da

budu uređena prvo po uzrastu, a zatim po imenu. Dete koje je ima isto ime i isto meseci se inicijalno stavlja u
desno podstablo u odnosu na posmatrani čvor. Na ulazu se najpre zadaje nenegativan ceo broj N koji predstavlja
broj dece koja dobijaju poklone, a zatim se za svako dete unose ime, uzrast i broj igračaka.

Nakon završenog rasporeda dece štampati podatke počev od najstarijeg deteta.

Ažurirati kreirani raspored dece za narednu godinu, ukoliko se zna da deca starija od X godina više ne dobijaju
poklone od Deda Mraza. (Brisanje bez kreiranja novog stabla donosi bonus od 3 poena.)

Štampati novi raspored dece.
Štampati imena i uzraste dece koja se nalaze na nivou K i dobili su M poklona (K i M se unose na ulazu).
*/

typedef struct data_s
{
    char *IME;
    int UZRAST;
    int BROJ_IGRACAKA;
}data;

typedef struct drvo_s
{
    data podatak;
    int balans;

    struct drvo_s *levi, *desni;
}drvo;

int dubina (drvo *p)
{
    if (!p)
        return 0;
    int dl = dubina (p->levi);
    int dd = dubina(p->desni);

    return ( dl > dd ? ++dl:++dd);
}


int racunaj_balans (drvo *p)
{
    if (p)
    {
        return ( dubina (p->desni) - dubina(p->levi));


    }
    else
        return 0;

}


void lr (drvo **p)
{
    drvo *l, *d;


    l = *p;
    d = l->desni;
    l->desni = d->levi;
    d->levi = l;
    *p = d;

    l->balans = racunaj_balans(l);
    d->balans = racunaj_balans(d);


}

void dr (drvo **p)
{
    drvo *l, *d;


    d = *p;
    l = d->levi;
    d->levi = l->desni;
    l->desni = d;
    *p = l;

    l->balans = racunaj_balans(l);
    d->balans = racunaj_balans(d);


}

void sredi (drvo **p)
{
    if (!(*p))
        return;

    drvo *t = *p;

    if (t->balans < -1)
    {
        if (t->levi->balans < 0)
            dr (&t);
        else
        {
            lr (& (t->levi));
            dr (&t);
        }
    }

    if (t->balans > 1)
    {
        if (t->desni->balans > 0)
            lr (&t);
        else
        {
            dr (& (t->desni));
            lr (&t);
        }
    }

    *p = t;
}

int rasporedi(int xuzrast, char *xime, int yzrast, char *yime)
{
    /*
           Deca treba da
           budu uređena prvo po uzrastu, a zatim po imenu. Dete koje je ima isto ime i isto meseci se inicijalno stavlja u
           desno podstablo u odnosu na posmatrani čvor
    */
    // -1 u levo
    // x je onaj koji dodajem

    if (xuzrast < yzrast)
        return -1;
    else if ( ( xuzrast ==  yzrast) && (strcmp(xime, yime) < 0))
        return -1;
    else
        return 1;



}


int dodaj (drvo **p, data dod)
{
    int rez = 0, ink;
    drvo *t = *p;
    int ind;

    if (!t)
    {
        t = (drvo*) malloc (sizeof (drvo));
        t->podatak = dod;
        t->levi = t->desni = NULL;
        t->balans = 0;

        rez = 1;
    }
    else
    {
        ind = rasporedi(dod.UZRAST, dod.IME,t->podatak.UZRAST, t->podatak.IME );

        if (ind == 1)
            ink = dodaj ( &(t->desni), dod);
        else
            ink = -dodaj (& (t->levi), dod);

        t->balans += ink;

        if (t->balans && ink)
        {

            if (t->balans < -1)
            {
                if (t->levi->balans < 0)
                    dr (&t);
                else
                {
                    lr (& (t->levi));
                    dr (&t);
                }
            }
            else if (t->balans > 1)
            {
                if (t->desni->balans > 0)
                    lr (&t);
                else
                {
                    dr (& (t->desni));
                    lr (&t);
                }
            }
            else
                rez = 1;
        }
    }




    *p = t;
    return rez;

}


drvo* form(void)
{
    /*
    Na ulazu se najpre zadaje nenegativan ceo broj N koji predstavlja
    broj dece koja dobijaju poklone, a zatim se za svako dete unose ime, uzrast i broj igračaka.
    */

    int N, i;
    data dod;
    drvo *p = NULL;


    scanf ("%d", &N);
    char ime[100];
    int uzrast, broj;

    for (i = 0; i < N; i++)
    {
        scanf ("%s%d%d", ime, &uzrast, &broj);
        dod.IME = (char*)malloc(sizeof(ime) + 1);
        strcpy(dod.IME, ime);
        dod.BROJ_IGRACAKA = broj;
        dod.UZRAST = uzrast;

        dodaj (&p, dod);
    }

    return p;
}

void ispis (drvo *p)
{
    if (!p)
        return;

    ispis(p->desni);

    printf("%s %d %d\n", p->podatak.IME, p->podatak.UZRAST, p->podatak.BROJ_IGRACAKA);

    ispis (p->levi);

}


data nadji (drvo **p)
{
    drvo *t = *p;
    data rez;
    drvo *pom;

    if (!t->levi)
    {
        rez = t->podatak;
        pom = t;
        t = t->desni;
        free (pom);
    }
    else
        rez = nadji (&(t->levi));

    if (t)
    {
        t->balans = racunaj_balans(t);
        sredi (&t);
    }




    *p = t;
    return rez;
}




drvo* obrisi (drvo *p, int x , int *ind)
{
/*
    Ažurirati kreirani raspored dece za narednu godinu, ukoliko se zna da deca starija od X godina više ne dobijaju
    poklone od Deda Mraza. (Brisanje bez kreiranja novog stabla donosi bonus od 3 poena.)
*/

    // x je u godinama
    // m u mesecima

    if (!p)
        return NULL;

    int m = x *12;
    //
    // starija od m mesecaaAA
    // p->podatak.UZRAST je kolko sada ima, + 12 je kolko ce da ima sl godine
    // ako je to vece ili jednako od m meseci onda ispada sa spiska

    drvo *pom;

    if (p->podatak.UZRAST + 12 >= m)
    {
        *ind = 1;
        if ( !p->levi && !p->desni)
        {
            free (p);
            return NULL;
        }

        if (p->levi && !p->desni)
        {
            pom = p->levi;
            free (p);
            return pom;
        }

        if (!p->levi && p->desni)
        {
            pom = p->desni;
            free (p);
            return pom;
        }

        if (p->levi && p->desni)
        {
            p->podatak = nadji (&(p->desni));
            p->balans = racunaj_balans(p);
            sredi (&p);
            return p;
        }



    }

    if (p->levi)
    {
        p->levi = obrisi(p->levi, x, ind);
        p->balans = racunaj_balans(p);
        sredi (&p);
    }

    if (p->desni)
    {
        p->desni = obrisi(p->desni, x, ind);
        p->balans = racunaj_balans(p);
        sredi (&p);
    }


    return p;




}

int nivo_cvora (drvo *koren, drvo *trazeni)
{
    //prvi m drugi ide
    // poc je koren
    int nivo = 1;

    if (koren == trazeni)
        return nivo;

    while (koren && koren != trazeni)
    {
        if (trazeni->podatak.UZRAST > koren->podatak.UZRAST)
            koren = koren->desni;
        else  if (trazeni->podatak.UZRAST == koren->podatak.UZRAST &&  ( strcmp(trazeni->podatak.IME, koren->podatak.IME) >= 0) )
                 koren = koren->desni;
        else
                koren = koren->levi;

        nivo++;

    }


    return nivo;
}


void f(drvo *poc, drvo *trazeni, int K, int M)
{
    /*
    Štampati imena i uzraste dece koja se nalaze
    na nivou K i dobili su M poklona (K i M se unose na ulazu).
    */
    // u poc je koren
    // ako je na nivou K i ima M poklona stampaj ga

    int level = nivo_cvora(poc, trazeni);
    // prvi m drugi ide

    if (level <= 3)
    {

    if ( level == K && (trazeni->podatak.BROJ_IGRACAKA == M) )
            printf("%s %d \n", trazeni->podatak.IME, trazeni->podatak.UZRAST);

    if (trazeni->levi)
        f (poc, trazeni->levi, K, M);

    if (trazeni->desni)
        f (poc, trazeni->desni, K, M);



    }



}


int main(void)
{
    drvo *p = form();

    ispis (p);


    int ind = 1;
    int x;

    scanf ("%d", &x);

    while(ind)
    {
        ind = 0;
        p = obrisi(p, x, &ind);
    }


    printf("Nakon azuriranja :\n");

    ispis (p);

    int k, m;

    scanf ("%d%d", &k, &m);

    f (p, p, k, m);







    return 0;

}

